﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace AirplaneWithRadar
{
    internal class DrawningAirplanePortholes : IAirplanePortholes
    {
        private CountPortholes _countPortholes;

        public int CountPortholes
        {
            set
            {
                _countPortholes = (CountPortholes)(value);
            }
        }

        public void DrawPortholes(Graphics g, int _startPosX, int _startPosY, int _airplaneWidth)
        {
            int middle = _startPosX + ((_airplaneWidth - 25) / 2);
            DrawPorthole(g, middle, _startPosY);
            int left = middle - 5;
            int right = middle + 5;
            for (var i = 1; i <= (int)_countPortholes / 4; i += 1)
            {
                DrawPorthole(g, left, _startPosY);
                left -= 5;
                DrawPorthole(g, right, _startPosY);
                right += 5;
            }
        }

        protected virtual void DrawPorthole(Graphics g, int _startPosX, int _startPosY)
        {
            Pen pen = new(Color.Black);
            g.DrawRectangle(pen, _startPosX, _startPosY, 2, 2);
        }
    }
}