namespace AirplaneWithRadar
{
    public partial class FormAirplane : Form
    {
        private DrawningAirplane _airplane;

        /// <summary>
        ///  
        /// </summary>
        public DrawningAirplane SelectedAirplane { get; private set; }

        public FormAirplane()
        {
            InitializeComponent();
        }

        /// <summary>
        ///   
        /// </summary>

        private void Draw()
        {
            Bitmap bmp = new(pictureBoxAirplane.Width, pictureBoxAirplane.Height);
            Graphics gr = Graphics.FromImage(bmp);
            _airplane?.DrawTransport(gr);
            pictureBoxAirplane.Image = bmp;
        }

        /// <summary>
        ///   
        /// </summary>
        private void SetData()
        {
            Random rnd = new();
            _airplane.SetPosition(rnd.Next(20, 100), rnd.Next(20, 100), pictureBoxAirplane.Width, pictureBoxAirplane.Height);
            toolStripStatusLabelSpeed.Text = $": {_airplane.Airplane.Speed}";
            toolStripStatusLabelWeight.Text = $": {_airplane.Airplane.Weight}";
            toolStripStatusLabelBodyColor.Text = $": {_airplane.Airplane.BodyColor.Name}";
        }
        /// <summary>
        ///    ""
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        /// 

        private void ButtonCreate_Click(object sender, EventArgs e)
        {
            IAirplanePortholes typeAirplanePortholes = new DrawningAirplanePortholes();
            switch (comboBoxTypePortholes.Text)
            {
                case "":
                    typeAirplanePortholes = new DrawningDeltaPortholes();
                    break;
                case "":
                    typeAirplanePortholes = new DrawningRhombusPortholes();
                    break;
            }
            Random rnd = new();
            _airplane = new DrawningAirplane(rnd.Next(100, 300), rnd.Next(1000, 2000), Color.FromArgb(rnd.Next(0, 256), rnd.Next(0, 256), rnd.Next(0, 256)), typeAirplanePortholes);
            _airplane.DrawningPortholes.CountPortholes = Convert.ToInt32(comboBoxPortholes.Text);
            _airplane.SetPosition(rnd.Next(20, 100), rnd.Next(20, 100), pictureBoxAirplane.Width, pictureBoxAirplane.Height);
            toolStripStatusLabelSpeed.Text = $": {_airplane.Airplane.Speed}";
            toolStripStatusLabelWeight.Text = $": {_airplane.Airplane.Weight}";
            toolStripStatusLabelBodyColor.Text = $": {_airplane.Airplane.BodyColor.Name}";
            Draw();
        }

        /// <summary>
        ///   
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void ButtonMove_Click(object sender, EventArgs e)
        {
            //  
            string name = ((Button)sender)?.Name ?? string.Empty;
            switch (name)
            {
                case "buttonUp":
                    _airplane?.MoveTransport(Direction.Up);
                    break;
                case "buttonDown":
                    _airplane?.MoveTransport(Direction.Down);
                    break;
                case "buttonLeft":
                    _airplane?.MoveTransport(Direction.Left);
                    break;
                case "buttonRight":
                    _airplane?.MoveTransport(Direction.Right);
                    break;
            }
            Draw();
        }
        /// <summary>
        ///   
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void PictureBoxAirplane_Resize(object sender, EventArgs e)
        {
            _airplane?.ChangeBorders(pictureBoxAirplane.Width, pictureBoxAirplane.Height);
            Draw();
        }

        private void ButtonCreateModif_Click(object sender, EventArgs e)
        {
            IAirplanePortholes typeAirplanePortholes = new DrawningAirplanePortholes();
            switch (comboBoxTypePortholes.Text)
            {
                case "":
                    typeAirplanePortholes = new DrawningDeltaPortholes();
                    break;
                case "":
                    typeAirplanePortholes = new DrawningRhombusPortholes();
                    break;
            }
            Random rnd = new();
            _airplane = new DrawningAirplaneWithRadar(rnd.Next(100, 300), rnd.Next(1000, 2000),
            Color.FromArgb(rnd.Next(0, 256), rnd.Next(0, 256), rnd.Next(0, 256)),
            Color.FromArgb(rnd.Next(0, 256), rnd.Next(0, 256), rnd.Next(0, 256)),
            Convert.ToBoolean(rnd.Next(0, 2)),
            Convert.ToBoolean(rnd.Next(0, 2)),
            typeAirplanePortholes);
            _airplane.DrawningPortholes.CountPortholes = Convert.ToInt32(comboBoxPortholes.Text);
            SetData();
            Draw();
        }

        private void ButtonSelectAirplane_Click(object sender, EventArgs e)
        {
            SelectedAirplane = _airplane;
            DialogResult = DialogResult.OK;
        }
    }
}